<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>Boostrap Flex</title>

	<!-- bootstrap CSS -->
    <link   rel="stylesheet" 
            href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" 
            crossorigin="anonymous">

	<!-- external CSS -->
	<link rel="stylesheet" type="text/css" href="./index.css">

</head>
<body>
	<div class="container">
		<div class="row">
			<div class="col-md mx-md-auto bg-warning">
				<h1 class="text-center">Boostrap Flex</h1>
			</div>
		</div>
	</div>
	
	<!-- 
		flexbox is used to manipulate or layout our elements in one direction. This can be done extensively in CSS, however using bootstrap, we add the use to our elements quicker with the use of bootstrap classes.

		To add flexbox styles to our element, you have to add d-flex class to the parent element. Each of the direction child of the parent will become flex item.

		Flex Directions
		by default, adding d-flex would arrange the children/flex items into a row.
			- for block elements, it will no longer occupy the full width of its parent
		flex-row reverse - starts our items on the opposite side (right) and reverses the order of our flex items.

		flex-row - starts from left to right
		flex-row-reverse - starts from right to left

		flex-column - will arrange our items from top to bottom and by default, its children will occupy the width of its parent

		flex-column-reverse - does the same as the flex-column, but it starts from bottom to top.
	 -->

	<!-- flex-row - starts from left to right -->
	<h4 class="text-center">Flex Row</h4>
	<div class="d-flex flex-row bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<!-- flex-row-reverse - starts from right to left -->
	<h4 class="text-center">Flex Row Reverse</h4>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4 class="text-center">Flex Column</h4>
	<div class="d-flex flex-column bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4 class="text-center">Flex Column Reverse</h4>
	<div class="d-flex flex-column-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<!-- span as direct children of flex with flex-column -->
	<h4 class="text-center">Flex Column with Span</h4>
	<div class="d-flex flex-column bg-danger mb-4">
		<span class="bg-primary p-2">Flex item 1</span>
		<span class="bg-success p-2">Flex item 2</span>
		<span class="bg-danger p-2">Flex item 3</span>
	</div>

	<!-- justify content -->
	<h2 class="text-center">Justify content</h2>
	<!-- justify content - would allow us to change the alignment of our flex items along with its main axis. The main axis for items arranged with flex-row is the x-axis. For flex-column, this is reversed, wherein the main axis for flex-column is y-axis. -->
	<h4>Justify Content Start</h4>
	<!-- aligns our items where our main axis starts. For flex-row, the start is from the left. For flex-row-reverse, the start is from the right.  -->
	<div class="d-flex flex-row justify-content-start bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-row-reverse justify-content-end bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4>Justify Content End</h4>
	<!-- aligns our flex items where our main axis ends. For flex-row, the end is from the right, for flex-row-reverse, the end is from the left. -->
	<div class="d-flex flex-row justify-content-end bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-row-reverse justify-content-start bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4>Justify Content Center</h4>
	<!-- Align our items at the center of our main axis. The main axis for both flex-row and flex-row-reverse are in the x-axis, thus, centering our items horizontally. For flex-column and flex-column-reverse, this will center the items vertically. -->

	<div class="d-flex flex-row justify-content-center bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-row-reverse justify-content-center bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-column justify-content-center bg-dark mb-4">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-column-reverse justify-content-center bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4 class="text-center">Justify Content Between</h4>
	<!-- aligns our items by adding evenly distributed spaces between flex items. -->
	<div class="d-flex flex-row justify-content-between bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>	

	<h4 class="text-center">Justify Content Around</h4>
	<!-- aligns our items by distributing space around flex items. It will automatically calculate the space remaining and add that space on both sides of and element. -->
	<!-- flex wrap allows us to wrap our overflowing elements, such that if the children of our flex container exceeds the width, the flex items(children) will be put into the next line. -->
	<div class="d-flex flex-row justify-content-around flex-wrap bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<!-- align items -->
	<h2 class="text-center">Align Items</h2>
	<!-- align items - aligns items vertically for flex-row and flex-row reverse.
	For flex-column and flex-column reverse, this will align items horizontally -->
	<h4>Align Items Start</h4>
	<!-- align-items-start - aligns items at the start of the y-axis or cross axis. 
		For flex-row and flex-row-reverse, the cross axis is the y-axis and the main axis is the x-axis
			- align-items-start will vertically align our items from the start of the y-axis:
				for flex-row, this is the top
				for flex-row-reverse, this is the top
		For flex-column and flex-column-reverse, the cross axis is the x-axis, and the main-axis is the y-axis.
	-->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-column align-items-start bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4>Align Items End</h4>
	<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-column align-items-end bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4>Align Items Center</h4>
	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<h4>Align Items Center and Justify Content Center</h4>
	<div class="d-flex flex-column align-items-center justify-content-center bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-center bg-dark mb-4" style="height: 30vh;">
		<div class="bg-primary p-2">Flex item 1</div>
		<div class="bg-success p-2">Flex item 2</div>
		<div class="bg-danger p-2">Flex item 3</div>
	</div>

	<!-- js dependencies -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>